# Generated by Django 2.1.3 on 2019-03-15 09:25

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Ability',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=120)),
                ('descr', models.CharField(max_length=512)),
            ],
            options={
                'ordering': ('id',),
            },
        ),
        migrations.CreateModel(
            name='Settings',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('init', models.IntegerField(default=0)),
            ],
        ),
        migrations.CreateModel(
            name='Task',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=64)),
                ('descr', models.CharField(max_length=1024)),
            ],
        ),
        migrations.CreateModel(
            name='TaskAbility',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('level_min', models.FloatField()),
                ('level_max', models.FloatField()),
                ('ability', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='tasks', to='crowdpriv.Ability')),
                ('task', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='abilities', to='crowdpriv.Task')),
            ],
        ),
        migrations.CreateModel(
            name='Worker',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('real', models.BooleanField()),
                ('completed', models.BooleanField(default=False)),
            ],
            options={
                'ordering': ('id',),
            },
        ),
        migrations.CreateModel(
            name='WorkerAbility',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('level', models.FloatField()),
                ('ability', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='workers', to='crowdpriv.Ability')),
                ('worker', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='abilities', to='crowdpriv.Worker')),
            ],
            options={
                'ordering': ('ability',),
            },
        ),
        migrations.CreateModel(
            name='WorkersTree',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('table_cut', models.CharField(max_length=64)),
                ('cut', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='crowdpriv.Ability')),
            ],
        ),
        migrations.CreateModel(
            name='WorkersTreeMeta',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('generating', models.BooleanField(default=True)),
                ('time_start', models.DateTimeField(auto_now_add=True)),
                ('time_end', models.DateTimeField(auto_now=True)),
                ('expected', models.IntegerField()),
                ('current', models.IntegerField(default=0)),
                ('epsilon', models.FloatField()),
                ('prof_max', models.IntegerField()),
                ('bins', models.IntegerField()),
                ('ratio_count', models.FloatField()),
                ('coalition', models.IntegerField()),
                ('root', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='crowdpriv.WorkersTree')),
            ],
        ),
        migrations.CreateModel(
            name='WorkersTreeNode',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('app_count', models.IntegerField()),
                ('epsilon', models.FloatField()),
                ('z', models.FloatField(default=-1)),
                ('f', models.FloatField(default=-1)),
                ('beta', models.FloatField(default=-1)),
                ('alpha', models.FloatField()),
                ('peoples', models.ManyToManyField(to='crowdpriv.Worker')),
            ],
        ),
        migrations.CreateModel(
            name='WorkerTreeNodeVolume',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('min', models.FloatField()),
                ('max', models.FloatField()),
                ('ability', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='crowdpriv.Ability')),
            ],
            options={
                'ordering': ('ability',),
            },
        ),
        migrations.AddField(
            model_name='workerstreenode',
            name='volume',
            field=models.ManyToManyField(to='crowdpriv.WorkerTreeNodeVolume'),
        ),
        migrations.AddField(
            model_name='workerstree',
            name='node',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='tree', to='crowdpriv.WorkersTreeNode'),
        ),
        migrations.AddField(
            model_name='workerstree',
            name='parent',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='children', to='crowdpriv.WorkersTree'),
        ),
        migrations.AddField(
            model_name='task',
            name='tree',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='tasks', to='crowdpriv.WorkersTreeMeta'),
        ),
        migrations.AlterUniqueTogether(
            name='workertreenodevolume',
            unique_together={('ability', 'min', 'max')},
        ),
        migrations.AlterUniqueTogether(
            name='workerstreemeta',
            unique_together={('epsilon', 'prof_max', 'bins', 'ratio_count', 'coalition')},
        ),
        migrations.AlterUniqueTogether(
            name='workerability',
            unique_together={('worker', 'ability')},
        ),
        migrations.AlterUniqueTogether(
            name='taskability',
            unique_together={('task', 'ability')},
        ),
    ]
